#include "KMotionDef.h"
#include "Triac.h"
#include "KflopToKMotionCNCFunctions.c"
#include "TriacTC.c"
#include "TriacEStop.c"
#include "AdjustSoftLimits.c"
#include "MPGServiceSmoothHardwareEncFiltered.c"
#include "TriacControlPanel.c"

main()
{
	ch0->InputMode=NO_INPUT_MODE;
	ch0->OutputMode=STEP_DIR_MODE;
	ch0->Vel=54000;
	ch0->Accel=800000;
	ch0->Jerk=9e+06;
	ch0->P=0;
	ch0->I=0.01;
	ch0->D=0;
	ch0->FFAccel=0;
	ch0->FFVel=0;
	ch0->MaxI=200;
	ch0->MaxErr=1e+06;
	ch0->MaxOutput=200;
	ch0->DeadBandGain=1;
	ch0->DeadBandRange=0;
	ch0->InputChan0=0;
	ch0->InputChan1=0;
	ch0->OutputChan0=12;
	ch0->OutputChan1=0;
	ch0->MasterAxis=-1;
	ch0->LimitSwitchOptions=0x100;
	ch0->LimitSwitchNegBit=0;
	ch0->LimitSwitchPosBit=0;
	ch0->SoftLimitPos=1e+09;
	ch0->SoftLimitNeg=-1e+09;
	ch0->InputGain0=1;
	ch0->InputGain1=1;
	ch0->InputOffset0=0;
	ch0->InputOffset1=0;
	ch0->OutputGain=-1;
	ch0->OutputOffset=0;
	ch0->SlaveGain=1;
	ch0->BacklashMode=BACKLASH_OFF;
	ch0->BacklashAmount=0;
	ch0->BacklashRate=0;
	ch0->invDistPerCycle=1;
	ch0->Lead=0;
	ch0->MaxFollowingError=1000000000;
	ch0->StepperAmplitude=20;

	ch0->iir[0].B0=1;
	ch0->iir[0].B1=0;
	ch0->iir[0].B2=0;
	ch0->iir[0].A1=0;
	ch0->iir[0].A2=0;

	ch0->iir[1].B0=1;
	ch0->iir[1].B1=0;
	ch0->iir[1].B2=0;
	ch0->iir[1].A1=0;
	ch0->iir[1].A2=0;

	ch0->iir[2].B0=0.000768788;
	ch0->iir[2].B1=0.00153758;
	ch0->iir[2].B2=0.000768788;
	ch0->iir[2].A1=1.92076;
	ch0->iir[2].A2=-0.923833;

	ch1->InputMode=NO_INPUT_MODE;
	ch1->OutputMode=STEP_DIR_MODE;
	ch1->Vel=54000;
	ch1->Accel=800000;
	ch1->Jerk=9e+06;
	ch1->P=0;
	ch1->I=0.01;
	ch1->D=0;
	ch1->FFAccel=0;
	ch1->FFVel=0;
	ch1->MaxI=200;
	ch1->MaxErr=1e+06;
	ch1->MaxOutput=200;
	ch1->DeadBandGain=1;
	ch1->DeadBandRange=0;
	ch1->InputChan0=1;
	ch1->InputChan1=0;
	ch1->OutputChan0=13;
	ch1->OutputChan1=0;
	ch1->MasterAxis=-1;
	ch1->LimitSwitchOptions=0x100;
	ch1->LimitSwitchNegBit=0;
	ch1->LimitSwitchPosBit=0;
	ch1->SoftLimitPos=1e+09;
	ch1->SoftLimitNeg=-1e+09;
	ch1->InputGain0=1;
	ch1->InputGain1=1;
	ch1->InputOffset0=0;
	ch1->InputOffset1=0;
	ch1->OutputGain=1;
	ch1->OutputOffset=0;
	ch1->SlaveGain=1;
	ch1->BacklashMode=BACKLASH_OFF;
	ch1->BacklashAmount=0;
	ch1->BacklashRate=0;
	ch1->invDistPerCycle=1;
	ch1->Lead=0;
	ch1->MaxFollowingError=1000000000;
	ch1->StepperAmplitude=20;

	ch1->iir[0].B0=1;
	ch1->iir[0].B1=0;
	ch1->iir[0].B2=0;
	ch1->iir[0].A1=0;
	ch1->iir[0].A2=0;

	ch1->iir[1].B0=1;
	ch1->iir[1].B1=0;
	ch1->iir[1].B2=0;
	ch1->iir[1].A1=0;
	ch1->iir[1].A2=0;

	ch1->iir[2].B0=0.000769;
	ch1->iir[2].B1=0.001538;
	ch1->iir[2].B2=0.000769;
	ch1->iir[2].A1=1.92081;
	ch1->iir[2].A2=-0.923885;
	
	ch2->InputMode=NO_INPUT_MODE;
	ch2->OutputMode=STEP_DIR_MODE;
	ch2->Vel=54000;
	ch2->Accel=800000;
	ch2->Jerk=9e+06;
	ch2->P=0;
	ch2->I=0.01;
	ch2->D=0;
	ch2->FFAccel=0;
	ch2->FFVel=0;
	ch2->MaxI=200;
	ch2->MaxErr=1e+06;
	ch2->MaxOutput=200;
	ch2->DeadBandGain=1;
	ch2->DeadBandRange=0;
	ch2->InputChan0=2;
	ch2->InputChan1=0;
	ch2->OutputChan0=14;
	ch2->OutputChan1=0;
	ch2->MasterAxis=-1;
	ch2->LimitSwitchOptions=0x100;
	ch2->LimitSwitchNegBit=0;
	ch2->LimitSwitchPosBit=0;
	ch2->SoftLimitPos=1e+09;
	ch2->SoftLimitNeg=-1e+09;
	ch2->InputGain0=1;
	ch2->InputGain1=1;
	ch2->InputOffset0=0;
	ch2->InputOffset1=0;
	ch2->OutputGain=-1;
	ch2->OutputOffset=0;
	ch2->SlaveGain=1;
	ch2->BacklashMode=BACKLASH_OFF;
	ch2->BacklashAmount=0;
	ch2->BacklashRate=0;
	ch2->invDistPerCycle=1;
	ch2->Lead=0;
	ch2->MaxFollowingError=1000000000;
	ch2->StepperAmplitude=20;

	ch2->iir[0].B0=1;
	ch2->iir[0].B1=0;
	ch2->iir[0].B2=0;
	ch2->iir[0].A1=0;
	ch2->iir[0].A2=0;

	ch2->iir[1].B0=1;
	ch2->iir[1].B1=0;
	ch2->iir[1].B2=0;
	ch2->iir[1].A1=0;
	ch2->iir[1].A2=0;

	ch2->iir[2].B0=0.000769;
	ch2->iir[2].B1=0.001538;
	ch2->iir[2].B2=0.000769;
	ch2->iir[2].A1=1.92081;
	ch2->iir[2].A2=-0.923885;
	
	// MPG channel
	ch5->InputMode=ENCODER_MODE;
	ch5->OutputMode=NO_OUTPUT_MODE;
	ch5->Vel=40000;
	ch5->Accel=400000;
	ch5->Jerk=4e+06;
	ch5->P=0.2;
	ch5->I=0;
	ch5->D=0;
	ch5->FFAccel=0;
	ch5->FFVel=0;
	ch5->MaxI=200;
	ch5->MaxErr=200;
	ch5->MaxOutput=200;
	ch5->DeadBandGain=1;
	ch5->DeadBandRange=0;
	ch5->InputChan0=0;
	ch5->InputChan1=1;
	ch5->OutputChan0=5;
	ch5->OutputChan1=1;
	ch5->MasterAxis=-1;
	ch5->LimitSwitchOptions=0x100;
	ch5->LimitSwitchNegBit=0;
	ch5->LimitSwitchPosBit=0;
	ch5->SoftLimitPos=1e+09;
	ch5->SoftLimitNeg=-1e+09;
	ch5->InputGain0=1;
	ch5->InputGain1=1;
	ch5->InputOffset0=0;
	ch5->InputOffset1=0;
	ch5->OutputGain=1;
	ch5->OutputOffset=0;
	ch5->SlaveGain=1;
	ch5->BacklashMode=BACKLASH_OFF;
	ch5->BacklashAmount=0;
	ch5->BacklashRate=0;
	ch5->invDistPerCycle=1;
	ch5->Lead=0;
	ch5->MaxFollowingError=10000000;
	ch5->StepperAmplitude=250;

	ch5->iir[0].B0=1;
	ch5->iir[0].B1=0;
	ch5->iir[0].B2=0;
	ch5->iir[0].A1=0;
	ch5->iir[0].A2=0;

	ch5->iir[1].B0=1;
	ch5->iir[1].B1=0;
	ch5->iir[1].B2=0;
	ch5->iir[1].A1=0;
	ch5->iir[1].A2=0;

	ch5->iir[2].B0=1;
	ch5->iir[2].B1=0;
	ch5->iir[2].B2=0;
	ch5->iir[2].A1=0;
	ch5->iir[2].A2=0;

	// spindle channel
	ch7->InputMode=ENCODER_MODE;
	ch7->OutputMode=DAC_SERVO_MODE;
	ch7->Vel=500000;
	ch7->Accel=2000000;
	ch7->Jerk=3e+07;
	ch7->P=1.7;
	ch7->I=0.008;
	ch7->D=35;
	ch7->FFAccel=0;
	ch7->FFVel=0.003;
	ch7->MaxI=2047;
	ch7->MaxErr=2047;
	ch7->MaxOutput=2047;
	ch7->DeadBandGain=1;
	ch7->DeadBandRange=0;
	ch7->InputChan0=3;
	ch7->InputChan1=1;
	ch7->OutputChan0=7;
	ch7->OutputChan1=1;
	ch7->MasterAxis=-1;
	ch7->LimitSwitchOptions=0x100;
	ch7->LimitSwitchNegBit=0;
	ch7->LimitSwitchPosBit=0;
	ch7->SoftLimitPos=1e+30;
	ch7->SoftLimitNeg=-1e+30;
	ch7->InputGain0=-1;
	ch7->InputGain1=1;
	ch7->InputOffset0=0;
	ch7->InputOffset1=0;
	ch7->OutputGain=-1;
	ch7->OutputOffset=0;
	ch7->SlaveGain=1;
	ch7->BacklashMode=BACKLASH_OFF;
	ch7->BacklashAmount=0;
	ch7->BacklashRate=0;
	ch7->invDistPerCycle=1;
	ch7->Lead=0;
	ch7->MaxFollowingError=1000;
	ch7->StepperAmplitude=250;

	ch7->iir[0].B0=1.000000;
	ch7->iir[0].B1=0.000000;
	ch7->iir[0].B2=0.000000;
	ch7->iir[0].A1=0.000000;
	ch7->iir[0].A2=0.000000;

	ch7->iir[1].B0=1.000000;
	ch7->iir[1].B1=0.000000;
	ch7->iir[1].B2=0.000000;
	ch7->iir[1].A1=0.000000;
	ch7->iir[1].A2=0.000000;

	ch7->iir[2].B0=0.056605;
	ch7->iir[2].B1=0.113210;
	ch7->iir[2].B2=0.056605;
	ch7->iir[2].A1=1.228040;
	ch7->iir[2].A2=-0.454462;
	
	// Init Konnect
	InitAux();
	AddKonnect(0,&VirtualBitsEx,VirtualBitsEx+1);
	
	Delay_sec(0.1);	// we need a delay to allow the Konnect inputs to be updated to KFlop so the next bit works correctly (2 time slice delay needed, but we'll go for 0.1s for simplicity)
	
	// Stepper drive reset sequence start
	// if we don't have a full complement of OK signals, then we need to reset
	if(!ReadBit(XFAULT) || !ReadBit(YFAULT) || !ReadBit(ZFAULT))
	{
		printf("Stepper reset started\n");
		ClearBit(STEPENA);	// this should be disabled, but just in case.. (plus if it works, the next bit gets skipped!)
		Delay_sec(0.1);		// give the drives time to respond
		int attempts = 0;
		while(!ReadBit(XFAULT) || !ReadBit(YFAULT) || !ReadBit(ZFAULT))	// while any faults still active, we keep going
		{
			if(attempts > 1){	// if we've exceeded two reset attempts, we quit.
				printf("Stepper reset failed");
				MsgBox("Stepper drive reset failed",MB_OK|MB_ICONEXCLAMATION);
				break;
			}
			attempts++;
			SetBit(STEPENA);
			Delay_sec(0.2);
			ClearBit(STEPENA);		// drives reset on enable remove
			Delay_sec(0.2);
		}
		printf("Steppers reset\n");
	}
	// Stepper drive reset sequence finish
	
	SetBit(STEPENA);	// enable steppers

	EnableAxis(0);
	EnableAxis(1);
	EnableAxis(2);
	
	FPGA(STEP_PULSE_LENGTH_ADD)=63;  // set the pulse time to ~ 5.xus
	DefineCoordSystem(0,1,2,-1);
	
	SetBit(SYSTEMOK);
	ClearBit(ESTOPHANDLED);
	//SetBit(INIT);
	int lastCrslPos = 0;
	int *CrslPos		= &persist.UserData[CRSL_POS];
	int softLimitCheck = 0;

	for(;;)	// loop forever
	{
		if(*CrslPos != lastCrslPos){
			printf("Carousel Position changed - %d\n",*CrslPos);
			lastCrslPos = *CrslPos;
		}
		estop_test();
		ServiceToolChange();
		WaitNextTimeSlice();
		ServiceMPG();
		// Start of softlimit checks
		if(softLimitCheck == 0){
			CheckDistToStop(ch0);
			softLimitCheck++;
		} else if (softLimitCheck == 1){
			CheckDistToStop(ch1);
			softLimitCheck++;
		} else if (softLimitCheck == 2){
			CheckDistToStop(ch2);
			softLimitCheck = 0;
		}
		// End softlimit checks
		ServiceTower();	// handle our light tower
		ServiceButtons();
		ServicePots();
	}

    return 0;

}
