#include "KMotionDef.h"

main()
{

}

SpindleTest(){
// if spindle is in fault (normal during power up), we need to reset it before doing anything
	if(!ReadBit(SPDLOK))
	{
		printf("Spindle drive in fault. Reset intiated\n");
		ClearBit(SPDLENA);	// make sure spindle drive is disabled
		SetBit(SPDLRST);
		int inreset = TRUE;
		double resetTO = Time_sec() + TO_SPDLRST;
		while(inreset){
			if(resetTO < Time_sec())	// if we've exceeded time out time
			{
				ClearBit(SPDLRST);
				DoPC(PC_COMM_HALT);//activate feedhold in KMCNC
				printf("Spindle reset attempt timed out\n");
				MsgBoxNoWait("Spindle in fault and reset attempt failed. Feedhold activated.",MB_OK|MB_ICONEXCLAMATION);
				ThreadDone();
			}
			if(ReadBit(SPDLOK))		// if we have an OK signal, then we've succesfully reset drive
			{
				printf("Spindle drive reset succesful\n");
				ClearBit(SPDLRST);
				inreset = FALSE;
			}
		}
	}
}