#include "KMotionDef.h"
#include "triac.h"
//#include "KflopToKMotionCNCFunctions.c"

#define HOMINGAXIS X		// axis channel to home - Change this for each axis file (0=X, 1=Z)

main()
{
	printf("X Homing Call\n"); 
	SetBit(INHOMING);
	int homeSwitch, index,axisHomed;
	
	// configure required inputs for selected axis
	if (HOMINGAXIS == X){
		homeSwitch = XHOME;
		axisHomed = XHOMED;
	} else if (HOMINGAXIS == Y){
		homeSwitch = YHOME;
		axisHomed = YHOMED;
	} else if (HOMINGAXIS == Z){
		homeSwitch = ZHOME;
		axisHomed = ZHOMED;
	}
	
	// Set Soft Limits to large value
	ch0->SoftLimitPos=1e+09;
	ch0->SoftLimitNeg=-1e+09;
	
	Jog(HOMINGAXIS,10000);          	// start moving
	while (!ReadBit(homeSwitch)) ; 	// wait for switch (input #15) to change
	Jog(HOMINGAXIS,0);		      	// StopMotion
	
	while(!CheckDone(HOMINGAXIS)) ;
	
	Jog(HOMINGAXIS,-1000);          	// start moving
	while (ReadBit(homeSwitch)) ; 	// wait for switch (input #15) to change
	Jog(HOMINGAXIS,0);		      	// StopMotion
	
	while(!CheckDone(HOMINGAXIS));

	DisableAxis(HOMINGAXIS);
	Zero(HOMINGAXIS);
	ch0->SoftLimitPos=LIMITXPOS;
	ch0->SoftLimitNeg=LIMITXNEG;
	EnableAxisDest(HOMINGAXIS,0.0);
	
	SetBit(axisHomed);
	ClearBit(INHOMING);
}
